Ignatius has just come back school from the 30th ACM/ICPC. Now he has a lot of homework to do. Every teacher gives him a deadline of handing in the homework. If Ignatius hands in the homework after the deadline, the teacher will reduce his score of the final test. And now we assume that doing everyone homework always takes one day. So Ignatius wants you to help him to arrange the order of doing homework to minimize the reduced score.
Input
The input contains several test cases. The first line of the input is a single integer T that is the number of test cases. T test cases follow.
Each test case start with a positive integer N(1<=N<=1000) which indicate the number of homework.. Then 2 lines follow. The first line contains N integers that indicate the deadlines of the subjects, and the next line contains N integers that indicate the reduced scores.
Output
For each test case, you should output the smallest total reduced score, one line per test case.
Sample Input
3
3
3 3 3
10 5 1
3
1 3 1
6 2 3
7
1 4 6 4 2 4 3
3 2 1 7 6 5 4
Sample Output
0
3
5
解题思路:
这道题要用到贪心算法。贪心算法没有什么固定的模板,需要具体问题具体分析。
http://blog.csdn.net/u011787119/article/details/39827039
http://blog.csdn.net/wishchin/article/details/40081049
这两篇博客是一个参考。
这道题要考虑两个因素,一个是截止日期,一个是要扣除的分数。最先考虑的一定是扣除分数多且马上就要截止的作业,最后考虑的一定是扣除分数少且很久之后才截止的作业。
所以按扣除分数降序和截止日期升序排序。从序列中的第一个作业开始做,每做一个作业就要将date[1000]数组中做作业的日期标记,如果一个作业找不到可以标记日期,将该作业扣除的分数加到结果中。
一开始,我是按第一天到deadline的顺序找可以标记的日期的,但我、后来发现这样做不是最优的。最优的顺序是尽量先标记deadline,如果不行,再从后往前找,这样可以尽量把前面的日期空出来,做其他作业。
#include<stdio.h>
#include<algorithm>
using namespace std;
struct node{
int ddl;
int sco;
} stu[1010];
int date[1010];
bool cmp(node x,node y)
{
if(x.sco!=y.sco) return x.sco>y.sco;
else return x.ddl<y.ddl;
}
int main()
{
int n,t,flag,res;
scanf("%d",&t);
for(int i=1;i<=t;i++)
{
memset(date,0,sizeof(date));
scanf("%d",&n);
for(int j=1;j<=n;j++)
{
scanf("%d",&stu[j].ddl);
}
for(int j=1;j<=n;j++)
{
scanf("%d",&stu[j].sco);
}
sort(stu+1,stu+n+1,cmp);
res=0;
for(int j=1;j<=n;j++)
{
flag=0;
for(int k=stu[j].ddl;k>=1;k--)
{
if(date[k]==0)
{
date[k]=1;
flag=1;
break;
}
}
if(flag==0)
{
res+=stu[j].sco;
}
}
printf("%d\n",res);
}
}